#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	"rpm.h"

// Է ĸó ȣ ̺
#define	ICP1	PD4

// 1  ̺
#define	OC1A	PB5

//-----------   ---------------------------------
// Էĸó ߻    
volatile long int	timer1 = 0, pid_timer = 0;
volatile long int	pulse = 0, pulse_array[PULSE_ARRAY], pulse_idx = 0;

// Ÿ̸/ī1 Է ĸó ͷƮ ߻
ISR(TIMER1_CAPT_vect){	pulse++;	}

//--------- rpm   ----------
volatile	double	rpm;

//----------- ͷƮ  ƾ ----------------------
// Ÿ̸/ī1 ÷ ͷƮ ߻
ISR(TIMER1_OVF_vect)
{	int	i;

	timer1++;
	if( timer1 == OVF_NUM_FOR_RPM){					// rpm  ֱⰡ Ǿ 
		pulse_array[pulse_idx] = pulse;			// 迭 
		pulse_idx = (pulse_idx + 1 >= PULSE_ARRAY) ? 0 : pulse_idx + 1;	// 迭 ġ 
		for(i=0, pulse=0; i<PULSE_ARRAY; i++)	pulse +=pulse_array[i];
		rpm = RPM_BY_PULSE( pulse ) / PULSE_ARRAY;

		pulse = 0;
		timer1 = 0;
	}
}

// Է ĸó ʱȭ
void	ICP1_input_capture_init(void)
{
	DDRD &= ~(1<<ICP1);	// Էĸó1  Է¹
	PORTD |= 1<<ICP1;	//  Ǯ
}

// Ÿ̸/ī1 10bit OC1A PWM ʱȭ
void	TCNT1_PWM_10bit_init(void)
{
	// TCNT1 10 Ʈ  PWM  
	TCCR1B |= 1<<WGM12;				// 10 Ʈ  PWM ߻
	TCCR1A |= 1<<WGM11 | 1<<WGM10;
	TCCR1B |= 1<<CS12;				// 256 
	TIMSK |= 1<<TOIE1 | 1<<TICIE1;	// Ÿ̸/ī1 ÷, Էĸó ͷƮ Ȱȭ
	TCCR1B |= 1<<ICNC1 | 1<<ICES1;	//  ĵ, ¿ 

	// OC1A PWM 
	DDRB |= 1<<OC1A;		// OC1A  
	TCCR1A |= 1<<COM1A1;	// TCNT1  ִ밪  1, µ OCR1A ġϸ 0
}
