#ifndef	__RPM_H__
#define	__RPM_H__

// CPU ļ, Project => Configuration Options => General  
#define	F_CPU	8000000UL

#define	PULSE_ARRAY		2		//  rpm   迭 
#define	OVF_NUM_FOR_RPM	20		// 1ȸ rpm   ÷ Ƚ
#define	MAX_TCNT_BITS	10		// 1ȸ ÷θ  Ÿ̸/ī  
#define	OVF_TCOUNT	(1<<MAX_TCNT_BITS)	// ÷δ ִ TCNT īƮ 
#define	TCNT_PRESCALE	256		// Ÿ̸/ī 1  ҿǴ CPU Ŭ 
#define	SEC_TCNT_CLOCK		((double)TCNT_PRESCALE/(double)F_CPU)	// Ÿ̸/ī 1 ũϴ ҿ ð
#define	SEC_RPM_INTERVAL	(OVF_NUM_FOR_RPM * OVF_TCOUNT * SEC_TCNT_CLOCK )	// rpm  ֱ

#define	HOLE_PER_CYCLE	8	// 1ȸ ߻Ǵ  ͷƮ ޽
#define	MOTOR_GEAR	95		// ū   
#define	DISK_GEAR	19		//    
#define	GEARRATIO	((double)DISK_GEAR/(double)MOTOR_GEAR)	//   

// ޽, , , Ŭ  ޽  rpm 
#define	RPM_BY_PULSE(pulse)		(60.*pulse*GEARRATIO/(double)(SEC_RPM_INTERVAL*HOLE_PER_CYCLE))

extern volatile 	double	rpm;
volatile long int	timer1;

extern void	ICP1_input_capture_init(void);
extern void	TCNT1_PWM_10bit_init(void);

#endif
